// $Id: JareShell.java,v 1.15 2001/08/12 19:20:06 ioerger Exp $

/*** 
to do...
  exceptions - JareParseError, lookup?
  enumerate solutions, also return all
done...
  enhance shell commands - load, reset, show
  handle Vectors as bindings, in addition to Strings
  make utilities in JareCommon static
  load indicates when file not found
  add get_hash() to JareEngine
***/

package Jare;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Vector;

class JareShell
{
  static public void main(String args[])
  {
    JareShell shell=new JareShell(args);
  }

  public JareShell(String args[])
  {
    System.out.println("Welcome to JARE - Java Automated Reasoning Engine");
    System.out.println("Dr. Thomas R. Ioerger, Copyright 2000");
    //System.out.println("Version v1.0 (3/13/00)");
    //System.out.println("Version v1.1 (3/19/00)");
    //System.out.println("Version v1.3 (5/29/00)"); // fixed parser
    //System.out.println("Version v1.4 (8/8/00)"); // now in CVS 
    //System.out.println("Version v1.5 (8/20/00)"); // release V_1_5
    // R_1_6 (11/11/0) - added assert & retract 
    //System.out.println("Version 1.6 (11/10/00)"); 
    // R_1_7 (1/15/01) - added /**/ comments, fixed bug for lastEnv in next()
    //System.out.println("Version 1.7 (1/15/01)"); 
    // v1.7a (1/16/01) - minor fixes (no release tag)
    // v1.7b (7/18/01) - minor fixes (no release tag)
    //System.out.println("Version 1.7b (7/18/01)"); 
    System.out.println("Version 1.8 (8/12/01)"); 
    System.out.println("Type 'quit' to exit.");
    System.out.println("");

    JareEngine engine=new JareEngine();
    //engine.readKBfile("list.kb");
    if (args.length>0) // just read first file, skip extra args
      engine.readKBfile(args[0]);
    test_backchainer(engine);
  }

  void test_backchainer(JareEngine engine)
  {
    String buf=get_input();
    while (!J.stringEq(buf,"quit"))
    {
      Vector tree=new Vector();
      try { tree = J.parse(buf); }
      catch (JareParseError p) { System.out.println(p); }
      // better be something here; 1st had better be a Vector; ignore rest
     if (tree.size()>0)
     {
      if (!J.isVector(tree.elementAt(0)))
        System.out.println("error: command not understood: "+tree);
      else
      {
        tree = (Vector)tree.elementAt(0); 
        if ((tree.size()==0)||(!J.isString(tree.elementAt(0))))
          System.out.println("error: command not understood");

        else if (J.stringEq((String)tree.elementAt(0),"query-one"))
        {
          tree.removeElementAt(0);
          JareEnv solution = engine.query(tree);
          if (solution==null) System.out.println("fail");
          else System.out.println(J.treeToString(solution.subst(tree)));
        }

        else if (J.stringEq((String)tree.elementAt(0),"set-trace"))
        {
          if ((tree.size()>=2)&&(J.isString(tree.elementAt(1)))
              &&(J.stringEq((String)tree.elementAt(1),"on")))
            engine.setTrace(true);
          if ((tree.size()>=2)&&(J.isString(tree.elementAt(1)))
              &&(J.stringEq((String)tree.elementAt(1),"off")))
            engine.setTrace(false);
        }

        else if ((J.stringEq((String)tree.elementAt(0),"query-all"))
                ||(J.stringEq((String)tree.elementAt(0),"query")))
        {
          tree.removeElementAt(0);
          JareEnv solution = engine.query(tree);
          if (solution==null) System.out.println("fail");
          while (solution!=null)
          {
            System.out.println(J.treeToString(solution.subst(tree)));
            solution = engine.next();
          }
        }

        // assert one or more facts, e.g. (assert (color purple) (dog fido))

        else if (J.stringEq((String)tree.elementAt(0),"assert"))
        {
          for (int i=1 ; i<tree.size() ; i++)
          {
            Vector fact=(Vector)tree.elementAt(i);
            System.out.println("asserting: "+fact);
            engine.addFact(fact); // nest in 2 vectors to call addClauses
          }
        }

        // retract any clauses whose head unifies

        else if (J.stringEq((String)tree.elementAt(0),"retract"))
        {
          for (int i=1 ; i<tree.size() ; i++)
          {
            Vector fact=(Vector)tree.elementAt(i);
            System.out.println("retracting: "+fact);
            engine.retract(fact); 
          }
        }

        else if (J.stringEq((String)tree.elementAt(0),"load"))
        {
          if ((tree.size()!=2)||(!J.isString(tree.elementAt(1))))
            warn("must give name of file to load");
          else engine.readKBfile((String)tree.elementAt(1));
        }

        else if (J.stringEq((String)tree.elementAt(0),"reset"))
          engine.reset(); 

        else if (J.stringEq((String)tree.elementAt(0),"show"))
          engine.printKB(); 

        else System.out.println("error: command not understood");
      }
     }
      System.out.println();
      buf = get_input();
    }
  }

  String get_input()
  {
    String s=new String();
    int i;

    System.out.print(">");
    System.out.flush();

    try { 
      s = (new BufferedReader(new InputStreamReader(System.in))).readLine();
    } catch (Exception e) { System.out.println(e); }
    return s; // not used; only to suppress compiler complaints
  }

  public void die(String s)
  {
    System.out.print("Error: ");
    System.out.println(s);
    System.exit(-1);
  }

  public void warn(String s)
  {
    System.out.println("warning: "+s);
  }
}
