/*
 * $Id$
 */
package simulation;

import gui.MapView;

/**
 * @author Kai Sterker
 *
 */
public class Environment {

	public final static int DEAD = 0;
	public final static int WON = 1;
	public final static int RUNNING = 2;
	
	private Karte karte = null;
	private Karte welt = null;
	private Agent agent = null;
	private boolean init = true;
	
	public Environment () {
		karte = new Karte (Feld.ROT);
		welt = new Karte (0);
		// welt.standartWelt ();
		welt.zufallsWelt ();
		
		agent = new Agent (3, 0);
		agent.nehmeWahr (erzeugeWahrnehmung ());
	}
	
	/**
	 * 
	 */
	public int update() {
		Aktion a = agent.update ();
		welt.remove (agent.getPosX(), agent.getPosY(), agent.toString ());
		
		if (a.getAktion ().matches ("forward")) 
			agent.forward ();
		else if (a.getAktion ().matches ("turn-left")) 
			agent.turn_left ();
		else if (a.getAktion ().matches ("turn-right")) 
			agent.turn_right ();
		else if (a.getAktion().matches ("grab"))
			welt.remove (agent.getPosX(), agent.getPosY(), "gold");
		else if (a.getAktion().matches ("climb"))
			return WON;
		else if (a.getAktion().matches("die"))
			return DEAD;
			
		System.out.println ("Agent (" + agent.getPosX() + ", " + 
			agent.getPosY() + "), " + agent.getOrientierung ());
		welt.add (agent.getPosX(), agent.getPosY(), agent.toString ());

		agent.nehmeWahr (erzeugeWahrnehmung ());
		
		return RUNNING;
	}
	
	public Wahrnehmung erzeugeWahrnehmung () {
		return welt.erzeugeWahrnehmung (agent.getPosX(), agent.getPosY());
	}

	/**
	 * @param ansicht
	 * @return
	 */
	public Karte getKarte (int ansicht) {
		// Benutzersicht
		if (ansicht == MapView.WORLD_VIEW) return welt;
		
		// Sicht des Agenten
		if (init == true) {
			karte.initFromAgent (agent);
			init = false;
		}
		else 
			karte.fromAgent (agent);
		
		return karte;
	}
}